<template lang="pug">
  .video-card
    .card-top
      .card-img(:style="`background-image: url('${info.thumbnail}')`")
      .card-duration
        span {{durationMSFormat}}
    .card-content
      .card-desc
        span {{info.title}}
      .card-views
        i.material-icons headset
        span {{info.views}}
    .card-tags
      .tag(v-for="(item, index) in infoTags" :key="index" :style="`background: ${item.color}`")
        span {{item.text}}
</template>

<script>
  export default {
    props: {
      info: {
        type: Object,
        default: () => {
          return {
            captions: [],
            collectCount: 0,
            duration: 0,
            id: 0,
            level: 0,
            publish: 0,
            thumbnail: '',
            title: '',
            views: 0
          }
        }
      }
    },
    computed: {
      durationMSFormat () {
        let minutes = this.info.duration / 60 > 0 ? Math.floor(this.info.duration / 60) : 0
        let seconds = this.info.duration % 60
        return `${minutes.toString().padStart(2, '0')}:${seconds.toString().padStart(2, '0')}`
      },
      infoTags () {
        let result = []
        this.info.captions.forEach(obj => {
          result.push(this.$__langObj(obj))
        })
        result.push(this.$__levelObj(this.info.level))
        return result
      },
    },
    methods: {
      $__levelObj (level) {
        let levelStr = ''
        let levelColor = ''
        switch (level) {
          case 1:
            levelStr = '初級'
            levelColor = '#37C597'
            break
          case 2:
            levelStr = '中級'
            levelColor = '#FFC400'
            break
          case 3:
            levelStr = '中高級'
            levelColor = '#FF3D00'
            break
          case 4:
            levelStr = '高級'
            levelColor = '#BF360C'
            break
        }
        return {
          text: levelStr,
          color: levelColor
        }
      },
      $__langObj (lang) {
        let langStr = ''
        let langColor = ''
        switch (lang) {
          case 'cht':
            langStr = '中文'
            langColor = '#4283E4'
            break
          case 'ja':
            langStr = '日文'
            langColor = '#4283E4'
            break
          case 'vi':
            langStr = '越南文'
            langColor = '#4283E4'
            break
          case 'en':
            langStr = '英文'
            langColor = '#4283E4'
            break
        }
        return {
          text: langStr,
          color: langColor
        }
      }
    }
  }
</script>

<style lang="sass" scoped>

  =flex
    display: flex
    justify-content: center
    align-items: center

  =size($w, $h:$w)
    width: $w
    height: $h

  .video-card
    margin: 10px
    border-radius: 4px
    +size(240px, 228px)
    box-shadow: 0 1px 3px 0 rgba(0,0,0,0.30)
    position: relative
    &:hover
      cursor: pointer

    .card-top
      overflow: hidden
      position: relative
      border-radius: 4px 4px 0 0

      .card-img
        +size(240px, 135px)
        position: relative
        background-size: 102%
        background-repeat: no-repeat
        background-position: 50% 50%

      .card-duration
        +size(39px, 20px)
        position: absolute
        bottom: 10px
        right: 10px
        background: rgba(0,0,0,0.80)
        border-radius: 2px
        +flex
        span
          /*font-family: 'SFUIText-Medium'*/
          font-size: 12px
          color: #FFFFFF
          letter-spacing: 0
          line-height: 16px

    &:hover
      .card-img
        transition: 1s
        transform: scale(1.1)

    .card-content
      position: relative
      padding: 4px 8px
      text-align: left
      line-height: 17px
      letter-spacing: 0
      /*font-family: NotoSansCJKtc-Regular*/

      .card-desc
        +size(224px, 100%)
        max-height: 36px
        font-size: 14px
        color: #212B36
        display: -webkit-box
        -webkit-line-clamp: 2
        -webkit-box-orient: vertical
        overflow: hidden

      .card-views
        margin-top: 4px
        +flex
        justify-content: flex-start
        font-size: 14px
        color: #787878
        i
          margin-right: 5px
          font-size: 19px
    .card-tags
      position: absolute
      right: 8px
      bottom: 8px
      display: flex
      .tag
        padding: 2px 8px
        margin-left: 8px
        font-family: PingFangTC-Medium
        font-size: 12px
        color: #FFFFFF
        letter-spacing: -0.03px
        border-radius: 2px
</style>
